
!{{{ modul rutines

MODULE rutines

   implicit none 

        real*8  :: pi   

        real*8 r11, r21, r31, r12, r22, r32, r13, r23, r33

        real*8 alfa, beta, gama

        data pi         / 3.14159265358979d0 / 
   
CONTAINS

!{{{ subroutine  euler ()


      subroutine  euler ()

      implicit none 

      real*8  :: alfa_rad, beta_rad, gama_rad

      real*8  :: cbeta
      real*8  :: salfa, calfa
      real*8  :: sgama, cgama

!     calcul de beta:

      beta_rad = asin(-r31)


!     calcul de alfa:
      cbeta = cos (beta_rad)


      if ( abs(cbeta) .gt. 1.0D-6 ) then

        salfa = r21 / cbeta
        calfa = r11 / cbeta


!     calcul de gama:
        sgama = r32 / cbeta
        cgama = r33 / cbeta

        alfa_rad = atan2( salfa, calfa )
        gama_rad = atan2( sgama, cgama )

        write(*,*) ' Comprovacions: ' 
        write(*,*) 
        write(*,*) '    salfa = ', salfa
        write(*,*) ' sin alfa = ', sin (alfa_rad)
        write(*,*) 
        write(*,*) '    sgama = ', sgama
        write(*,*) ' sin gama = ', sin (gama_rad)
        write(*,*) 

      else

        alfa_rad = 0.0d0
        beta_rad = 0.0d0

      end if

        alfa = alfa_rad * 180.0d0 / pi
        beta = beta_rad * 180.0d0 / pi
        gama = gama_rad * 180.0d0 / pi

   end subroutine euler

!}}}


END MODULE rutines

!}}}


PROGRAM  p1   

   USE rutines      

      open(10,file='rijxcolumnes')
      read(10,*) r11, r21, r31, r12, r22, r32, r13, r23, r33
      close(10)

      call euler()

      open(11,file='fisef.out')
      write(11,1111) alfa, beta, gama       ! R_z, R_y, R_x
      close(11)
1111  format ( F13.5,  ',' , F13.5,  ',' ,  F13.5 )
   

END PROGRAM  p1

